import 'package:analyzer/dart/element/element.dart';
import 'package:build/build.dart';
import 'package:restoque_build/src/model/constructor.dart';
import 'package:source_gen/source_gen.dart';
import 'restoqueConstructorGenerator.dart';

import '../annotations.dart';

class RestoqueEntityGenerator extends GeneratorForAnnotation<RestoqueEntity> {
  @override
  Future<String> generateForAnnotatedElement(
      Element element, ConstantReader annotation, BuildStep buildStep) async {
    final tableName = annotation.read('tableName').literalValue as String;

    constructor constru = new constructor(
        element: element, className: element.name, tableName: tableName);
    String _class = await ConstructorGenerator.generate(constru);

    return "$_class";
  }
}
